package v0

type LegacyResponse struct {
	ID   string
	Data LegacyResponseData
	Type string
}

// ResponseData is where most of the data in the response is stored.
type LegacyResponseData struct {
	Groups          []Group
	Accounts        []Account
	URI             string
	DataMessage     DataMessage
	Message         string
	Username        string
	Source          JsonAddress
	SourceDevice    int
	Type            string
	IsReceipt       bool
	Timestamp       int64
	ServerTimestamp int64
}

// Group represents a group in signal
type Group struct {
	GroupID  string
	Members  []string
	Name     string
	AvatarID int
}

// Account represents a user account registered to signald
type Account struct {
	Username   string
	DeviceID   int
	Filename   string
	Registered bool
	HasKeys    bool `json:"has_keys"`
	Subscribed bool
}

// DataMessage is the main component of incoming text messages
type DataMessage struct {
	Timestamp        int64
	Body             string
	ExpiresInSeconds int64
	GroupInfo        IncomingGroupInfo `json:"group"`
}

// IncomingGroupInfo is information about a particular group
type IncomingGroupInfo struct {
	GroupID string
	Type    string
}
