package v1

// DO NOT EDIT: this file is automatically generated by ./tools/generator in this repo

import (
	"gitlab.com/signald/signald-go/signald/client-protocol/v0"
)

type Request struct {
	ID      string `json:"id"`
	Version string `json:"version"`
	Type    string `json:"type"`
}

type JsonAddress struct {
	Number string `json:"number,omitempty"` // An e164 phone number, starting with +. Currently the only available user-facing Signal identifier.
	Relay  string `json:"relay,omitempty"`
	UUID   string `json:"uuid,omitempty"` // A UUID, the unique identifier for a particular Signal account.
}

type JsonBlockedListMessage struct {
	Addresses []*JsonAddress `json:"addresses,omitempty"`
	GroupIds  []string       `json:"groupIds,omitempty"`
}

type JsonDataMessage struct {
	Attachments      []*v0.JsonAttachment `json:"attachments,omitempty"` // files attached to the incoming message
	Body             string               `json:"body,omitempty"`        // the text body of the incoming message.
	Contacts         []*v0.SharedContact  `json:"contacts,omitempty"`    // if the incoming message has a shared contact, the contact's information will be here
	EndSession       bool                 `json:"endSession,omitempty"`
	ExpiresInSeconds int32                `json:"expiresInSeconds,omitempty"` // the expiry timer on the incoming message. Clients should delete records of the message within this number of seconds
	Group            *JsonGroupInfo       `json:"group,omitempty"`            // if the incoming message was sent to a v1 group, information about that group will be here
	GroupV2          *JsonGroupV2Info     `json:"groupV2,omitempty"`          // is the incoming message was sent to a v2 group, basic identifying information about that group will be here. For full information, use list_groups
	Previews         []*v0.JsonPreview    `json:"previews,omitempty"`         // if the incoming message has a link preview, information about that preview will be here
	ProfileKeyUpdate bool                 `json:"profileKeyUpdate,omitempty"`
	Quote            *JsonQuote           `json:"quote,omitempty"`        // if the incoming message is a quote or reply to another message, this will contain information about that message
	Reaction         *JsonReaction        `json:"reaction,omitempty"`     // if the message adds or removes a reaction to another message, this will indicate what change is being made
	RemoteDelete     *v0.RemoteDelete     `json:"remoteDelete,omitempty"` // if the inbound message is deleting a previously sent message, indicates which message should be deleted
	Sticker          *v0.JsonSticker      `json:"sticker,omitempty"`      // if the incoming message is a sticker, information about the sicker will be here
	Timestamp        int64                `json:"timestamp,omitempty"`    // the (unix) timestamp that the message was sent at, according to the sender's device. This is used to uniquely identify this message for things like reactions and quotes.
	ViewOnce         bool                 `json:"viewOnce,omitempty"`     // indicates the message is a view once message. View once messages typically include no body and a single image attachment. Official Signal clients will prevent the user from saving the image, and once the user has viewed the image once they will destroy the image.
}

type JsonGroupInfo struct {
	AvatarId int64          `json:"avatarId,omitempty"`
	GroupId  string         `json:"groupId,omitempty"`
	Members  []*JsonAddress `json:"members,omitempty"`
	Name     string         `json:"name,omitempty"`
	Type     string         `json:"type,omitempty"`
}

type JsonGroupV2Info struct {
	ID                 string         `json:"id,omitempty"`
	InviteLinkPassword string         `json:"inviteLinkPassword,omitempty"`
	MasterKey          string         `json:"masterKey,omitempty"`
	Members            []*JsonAddress `json:"members,omitempty"`
	PendingMembers     []*JsonAddress `json:"pendingMembers,omitempty"`
	RequestingMembers  []*JsonAddress `json:"requestingMembers,omitempty"`
	Revision           int32          `json:"revision,omitempty"`
	Timer              int32          `json:"timer,omitempty"`
	Title              string         `json:"title,omitempty"`
}

type JsonMention struct {
	Length int32  `json:"length,omitempty"`
	Start  int32  `json:"start,omitempty"`
	UUID   string `json:"uuid,omitempty"`
}

type JsonMessageEnvelope struct {
	CallMessage              *v0.JsonCallMessage    `json:"callMessage,omitempty"`
	DataMessage              *JsonDataMessage       `json:"dataMessage,omitempty"`
	HasContent               bool                   `json:"hasContent,omitempty"`
	HasLegacyMessage         bool                   `json:"hasLegacyMessage,omitempty"`
	IsUnidentifiedSender     bool                   `json:"isUnidentifiedSender,omitempty"`
	Receipt                  *v0.JsonReceiptMessage `json:"receipt,omitempty"`
	Relay                    string                 `json:"relay,omitempty"`
	ServerDeliveredTimestamp int64                  `json:"serverDeliveredTimestamp,omitempty"`
	ServerTimestamp          int64                  `json:"serverTimestamp,omitempty"`
	Source                   *JsonAddress           `json:"source,omitempty"`
	SourceDevice             int32                  `json:"sourceDevice,omitempty"`
	SyncMessage              *JsonSyncMessage       `json:"syncMessage,omitempty"`
	Timestamp                int64                  `json:"timestamp,omitempty"`
	TimestampISO             string                 `json:"timestampISO,omitempty"`
	Type                     string                 `json:"type,omitempty"`
	Typing                   *v0.JsonTypingMessage  `json:"typing,omitempty"`
	Username                 string                 `json:"username,omitempty"`
	UUID                     string                 `json:"uuid,omitempty"`
}

type JsonMessageRequestResponseMessage struct {
	GroupId string       `json:"groupId,omitempty"`
	Person  *JsonAddress `json:"person,omitempty"`
	Type    string       `json:"type,omitempty"`
}

// JsonQuote: A quote is a reply to a previous message. ID is the sent time of the message being replied to
type JsonQuote struct {
	Attachments []*v0.JsonQuotedAttachment `json:"attachments,omitempty"`
	Author      *JsonAddress               `json:"author,omitempty"`
	ID          int64                      `json:"id,omitempty"`
	Mentions    []*v0.Mention              `json:"mentions,omitempty"`
	Text        string                     `json:"text,omitempty"`
}

type JsonReaction struct {
	Emoji               string       `json:"emoji,omitempty"`               // the emoji to react with
	Remove              bool         `json:"remove,omitempty"`              // set to true to remove the reaction. requires emoji be set to previously reacted emoji
	TargetAuthor        *JsonAddress `json:"targetAuthor,omitempty"`        // the author of the message being reacted to
	TargetSentTimestamp int64        `json:"targetSentTimestamp,omitempty"` // the client timestamp of the message being reacted to
}

type JsonReadMessage struct {
	Sender    *JsonAddress `json:"sender,omitempty"`
	Timestamp int64        `json:"timestamp,omitempty"`
}

type JsonSendMessageResult struct {
	Address             *JsonAddress `json:"address,omitempty"`
	IdentityFailure     string       `json:"identityFailure,omitempty"`
	NetworkFailure      bool         `json:"networkFailure,omitempty"`
	Success             *v0.Success  `json:"success,omitempty"`
	UnregisteredFailure bool         `json:"unregisteredFailure,omitempty"`
}

type JsonSentTranscriptMessage struct {
	Destination              *JsonAddress      `json:"destination,omitempty"`
	ExpirationStartTimestamp int64             `json:"expirationStartTimestamp,omitempty"`
	IsRecipientUpdate        bool              `json:"isRecipientUpdate,omitempty"`
	Message                  *JsonDataMessage  `json:"message,omitempty"`
	Timestamp                int64             `json:"timestamp,omitempty"`
	UnidentifiedStatus       map[string]string `json:"unidentifiedStatus,omitempty"`
}

type JsonSyncMessage struct {
	BlockedList            *JsonBlockedListMessage               `json:"blockedList,omitempty"`
	Configuration          *v0.ConfigurationMessage              `json:"configuration,omitempty"`
	Contacts               *v0.JsonAttachment                    `json:"contacts,omitempty"`
	ContactsComplete       bool                                  `json:"contactsComplete,omitempty"`
	FetchType              string                                `json:"fetchType,omitempty"`
	Groups                 *v0.JsonAttachment                    `json:"groups,omitempty"`
	MessageRequestResponse *JsonMessageRequestResponseMessage    `json:"messageRequestResponse,omitempty"`
	ReadMessages           []*JsonReadMessage                    `json:"readMessages,omitempty"`
	Request                string                                `json:"request,omitempty"`
	Sent                   *JsonSentTranscriptMessage            `json:"sent,omitempty"`
	StickerPackOperations  []*v0.JsonStickerPackOperationMessage `json:"stickerPackOperations,omitempty"`
	Verified               *JsonVerifiedMessage                  `json:"verified,omitempty"`
	ViewOnceOpen           *JsonViewOnceOpenMessage              `json:"viewOnceOpen,omitempty"`
}

type JsonVerifiedMessage struct {
	Destination *JsonAddress `json:"destination,omitempty"`
	IdentityKey string       `json:"identityKey,omitempty"`
	Timestamp   int64        `json:"timestamp,omitempty"`
	Verified    string       `json:"verified,omitempty"`
}

type JsonVersionMessage struct {
	Branch  string `json:"branch,omitempty"`
	Commit  string `json:"commit,omitempty"`
	Name    string `json:"name,omitempty"`
	Version string `json:"version,omitempty"`
}

type JsonViewOnceOpenMessage struct {
	Sender    *JsonAddress `json:"sender,omitempty"`
	Timestamp int64        `json:"timestamp,omitempty"`
}

// ReactRequest: react to a previous message
type ReactRequest struct {
	Request
	Reaction         *JsonReaction `json:"reaction,omitempty"`
	RecipientAddress *JsonAddress  `json:"recipientAddress,omitempty"`
	RecipientGroupID string        `json:"recipientGroupId,omitempty"`
	Timestamp        int64         `json:"timestamp,omitempty"`
	Username         string        `json:"username,omitempty"`
}

type SendRequest struct {
	Request
	Attachments      []*v0.JsonAttachment `json:"attachments,omitempty"`
	Mentions         []*JsonMention       `json:"mentions,omitempty"`
	MessageBody      string               `json:"messageBody,omitempty"`
	Quote            *JsonQuote           `json:"quote,omitempty"`
	RecipientAddress *JsonAddress         `json:"recipientAddress,omitempty"`
	RecipientGroupID string               `json:"recipientGroupId,omitempty"`
	Timestamp        int64                `json:"timestamp,omitempty"`
	Username         string               `json:"username,omitempty"`
}

type SendResponse struct {
	Results   []*JsonSendMessageResult `json:"results,omitempty"`
	Timestamp int64                    `json:"timestamp,omitempty"`
}

type VersionRequest struct {
	Request
}
